/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.equivalencia;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.ClaseservicioEquivalencia;
import com.rjconsultores.ventaboletos.entidad.ComisionistaExterno;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.service.ComisionistaExternoService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderClaseservicioEquivalencia;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busqeudaClaseservicioEquivalenciaController")
@Scope("prototype")
public class BusqeudaClaseservicioEquivalenciaController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<ClaseservicioEquivalencia> plwClaseservicioEquivalencia;
    @Autowired
    private ComisionistaExternoService comisionistaExternoService;
    @Autowired
    private ClaseServicioService claseServicioService;
    private MyListbox claseServicioEquivalenciaList;
    private Paging pagingClaseServicioEquivalencia;
    private Combobox cmbClaseServicio;
    private Combobox cmbComissionestaExterno;
    private Textbox txtEquivalencia;
    private List<ComisionistaExterno> lsComisionistaExterno;
    private List<ClaseServicio> lsClaservicio;

    public MyListbox getClaseServicioEquivalenciaList() {
        return claseServicioEquivalenciaList;
    }

    public void setClaseServicioEquivalenciaList(MyListbox claseServicioEquivalenciaList) {
        this.claseServicioEquivalenciaList = claseServicioEquivalenciaList;
    }

    public Combobox getCmbComissionestaExterno() {
        return cmbComissionestaExterno;
    }

    public void setCmbComissionestaExterno(Combobox cmbComissionestaExterno) {
        this.cmbComissionestaExterno = cmbComissionestaExterno;
    }

    public List<ComisionistaExterno> getLsComisionistaExterno() {
        return lsComisionistaExterno;
    }

    public void setLsComisionistaExterno(List<ComisionistaExterno> lsComisionistaExterno) {
        this.lsComisionistaExterno = lsComisionistaExterno;
    }

    public Paging getPagingClaseServicioEquivalencia() {
        return pagingClaseServicioEquivalencia;
    }

    public void setPagingClaseServicioEquivalencia(Paging pagingClaseServicioEquivalencia) {
        this.pagingClaseServicioEquivalencia = pagingClaseServicioEquivalencia;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verClaseservicioEquivalencia(new ClaseservicioEquivalencia());
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsComisionistaExterno = comisionistaExternoService.obtenerTodos();
        lsClaservicio = claseServicioService.obtenerTodos();

        super.doAfterCompose(comp);

        claseServicioEquivalenciaList.setItemRenderer(new RenderClaseservicioEquivalencia());
        claseServicioEquivalenciaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                ClaseservicioEquivalencia c = (ClaseservicioEquivalencia) claseServicioEquivalenciaList.getSelected();
                verClaseservicioEquivalencia(c);
            }
        });

        cmbClaseServicio.focus();
        refreshLista();
    }

    private void verClaseservicioEquivalencia(ClaseservicioEquivalencia ce) {
        if (ce == null) {
            return;
        }

        Map args = new HashMap();
        args.put("claseservicioEquivalencia", ce);
        args.put("claseServicioEquivalenciaList", claseServicioEquivalenciaList);

        openWindow("/gui/equivalencia/editarClaseServicioEquivalencia.zul",
                Labels.getLabel("editarClaseservicioEquivalenciaController.window.title"),
                args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<ClaseservicioEquivalencia> parada =
                new HibernateSearchObject<ClaseservicioEquivalencia>(ClaseservicioEquivalencia.class, pagingClaseServicioEquivalencia.getPageSize());

        if (cmbClaseServicio.getSelectedItem() != null) {
            parada.addFilterEqual("claseservicio", (ClaseServicio) cmbClaseServicio.getSelectedItem().getValue());
        }

        Comboitem ce = cmbComissionestaExterno.getSelectedItem();
        if (ce != null) {
            ComisionistaExterno c = (ComisionistaExterno) ce.getValue();
            parada.addFilterEqual("comisionistaExterno", c);
        }
        if (!txtEquivalencia.getValue().equals("")) {
            parada.addFilterILike("equivalenciaId", txtEquivalencia.getValue());
        }
        parada.addFilterEqual("activo", Boolean.TRUE);

        parada.addSortAsc("claseservicio.descclase");

        plwClaseservicioEquivalencia.init(parada, claseServicioEquivalenciaList, pagingClaseServicioEquivalencia);

        if (claseServicioEquivalenciaList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busqeudaClaseservicioEquivalenciaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public List<ClaseServicio> getLsClaservicio() {
        return lsClaservicio;
    }

    public void setLsClaservicio(List<ClaseServicio> lsClaservicio) {
        this.lsClaservicio = lsClaservicio;
    }
}
